<template>
  <div class="cards-grid">
    <div v-if="properties === null" v-for="n in 10" class="card">
      <div class="top-img skeleton-anim"></div>
      <div class="content">
        <h3 class="skeleton-title skeleton-anim"></h3>
        <p class="skeleton-text skeleton-anim"></p>
        <p class="skeleton-text skeleton-anim"></p>
      </div>
    </div>

    <div v-else v-for="(property, index) in properties" class="card">
      <router-link :to="`/${property.address.city.name + '-' + property.address.city.zip}/${property.type.name}-${property.id}`">
        <div
            @touchmove="touchMove" @touchstart="touchPropertyId(index)" @touchend="touchEnd" class="card-image"
            @mouseenter="touchPropertyId(index)" @mousedown="touchStart" @mouseup="touchEnd"
            :style="{backgroundImage:`url(${property.pictures[photoArray[index].currentPhoto].url})`}">
        <div class="card-image-overlay">
          <div class="card-image-overlay-top">
            <div class="card-status">
              <h2>{{property.category.name}}</h2>
              <h2>{{property.type.name}}</h2>
            </div>
            <div class="card-image-overlay-btn">
              <span class="heart">
                <p>Favoris</p>
                <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512"><!--! Font Awesome Pro 6.1.1 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license (Commercial License) Copyright 2022 Fonticons, Inc. --><path d="M0 190.9V185.1C0 115.2 50.52 55.58 119.4 44.1C164.1 36.51 211.4 51.37 244 84.02L256 96L267.1 84.02C300.6 51.37 347 36.51 392.6 44.1C461.5 55.58 512 115.2 512 185.1V190.9C512 232.4 494.8 272.1 464.4 300.4L283.7 469.1C276.2 476.1 266.3 480 256 480C245.7 480 235.8 476.1 228.3 469.1L47.59 300.4C17.23 272.1 .0003 232.4 .0003 190.9L0 190.9z"/></svg>
              </span>
              <span class="compare">
                <p>Comparer</p>
                <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512"><!--! Font Awesome Pro 6.1.1 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license (Commercial License) Copyright 2022 Fonticons, Inc. --><path d="M424.1 287c-15.13-15.12-40.1-4.426-40.1 16.97V352H336L153.6 108.8C147.6 100.8 138.1 96 128 96H32C14.31 96 0 110.3 0 128s14.31 32 32 32h80l182.4 243.2C300.4 411.3 309.9 416 320 416h63.97v47.94c0 21.39 25.86 32.12 40.99 17l79.1-79.98c9.387-9.387 9.387-24.59 0-33.97L424.1 287zM336 160h47.97v48.03c0 21.39 25.87 32.09 40.1 16.97l79.1-79.98c9.387-9.391 9.385-24.59-.0013-33.97l-79.1-79.98c-15.13-15.12-40.99-4.391-40.99 17V96H320c-10.06 0-19.56 4.75-25.59 12.81L254 162.7L293.1 216L336 160zM112 352H32c-17.69 0-32 14.31-32 32s14.31 32 32 32h96c10.06 0 19.56-4.75 25.59-12.81l40.4-53.87L154 296L112 352z"/></svg>
              </span>
            </div>

          </div>
          <div v-if="photoArray[index].nbPhoto > 1" class="carousel">
            <span @click.prevent="previousPhoto(index)">
                <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 256 512"><!--! Font Awesome Pro 6.1.1 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license (Commercial License) Copyright 2022 Fonticons, Inc. --><path d="M192 448c-8.188 0-16.38-3.125-22.62-9.375l-160-160c-12.5-12.5-12.5-32.75 0-45.25l160-160c12.5-12.5 32.75-12.5 45.25 0s12.5 32.75 0 45.25L77.25 256l137.4 137.4c12.5 12.5 12.5 32.75 0 45.25C208.4 444.9 200.2 448 192 448z"/></svg>
            </span>
            <span @click.prevent="nextPhoto(index)">
                <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 256 512"><!--! Font Awesome Pro 6.1.1 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license (Commercial License) Copyright 2022 Fonticons, Inc. --><path d="M192 448c-8.188 0-16.38-3.125-22.62-9.375l-160-160c-12.5-12.5-12.5-32.75 0-45.25l160-160c12.5-12.5 32.75-12.5 45.25 0s12.5 32.75 0 45.25L77.25 256l137.4 137.4c12.5 12.5 12.5 32.75 0 45.25C208.4 444.9 200.2 448 192 448z"/></svg>
            </span>
          </div>

          <div>
            <div class="photo-nb">
              <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512"><!--! Font Awesome Pro 6.1.1 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license (Commercial License) Copyright 2022 Fonticons, Inc. --><path d="M194.6 32H317.4C338.1 32 356.4 45.22 362.9 64.82L373.3 96H448C483.3 96 512 124.7 512 160V416C512 451.3 483.3 480 448 480H64C28.65 480 0 451.3 0 416V160C0 124.7 28.65 96 64 96H138.7L149.1 64.82C155.6 45.22 173.9 32 194.6 32H194.6zM256 384C309 384 352 341 352 288C352 234.1 309 192 256 192C202.1 192 160 234.1 160 288C160 341 202.1 384 256 384z"/></svg>
              <p>&nbsp{{ photoArray[index].nbPhoto }}</p>
            </div>
            <h3 class="card-address">
              <svg class="location-point" version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px" viewBox="0 0 1000 1000" enable-background="new 0 0 1000 1000" xml:space="preserve">
              <metadata> Svg Vector Icons : http://www.onlinewebfonts.com/icon </metadata>
                <g><g transform="translate(0.000000,511.000000) scale(0.100000,-0.100000)"><path d="M4261.3,4991.4c-500.1-58.1-1023.1-257.3-1477.6-560.3c-244.9-164-653.7-564.5-819.7-805.2c-423.4-608.1-616.4-1342.7-552-2100.2c72.6-869.6,363.2-1803.4,896.5-2886.7C2912.4-2583.4,3671.9-3689.5,4363-4355.6c247-236.6,433.7-369.4,583.2-415.1c95.4-27,110-27,178.5,8.3C5469.1-4586,6394.7-3401,7094.1-2238.9C7876.4-939.7,8386.9,268.1,8555,1226.9c60.2,348.6,60.2,792.8,0,1083.3c-215.8,1029.3-944.3,1888.5-1977.7,2328.5c-437.9,186.8-890.3,294.7-1463.1,344.5C4736.5,5016.3,4497.9,5018.4,4261.3,4991.4z M5332.1,3082.2c342.4-87.2,701.5-315.4,923.5-589.4c193-238.7,325.8-599.7,325.8-886.2c0-276-99.6-695.2-220-935.9C6197.5,349,5934,83.4,5639.3-59.8c-265.7-126.6-427.5-163.9-728.4-163.9c-226.2,0-265.6,6.2-429.6,64.3C3835.9,66.8,3333.6,687.3,3238.2,1376.3c-41.5,290.5,27,682.8,168.1,960.8c236.6,466.9,649.6,722.2,1286.7,796.9C4834.1,3150.6,5174.4,3123.7,5332.1,3082.2z"/></g></g>
              </svg>
              <span>
                {{ property.address.city.name }}
              </span>
            </h3>
          </div>
        </div>
      </div>

      <div class="content">
        <h3 class="title">{{ property.title }}</h3>
        <h3 class="price">{{property.price}}</h3>
        <p class="text">{{ property.description }}</p>
      </div>
      </router-link>
    </div>

  </div>
</template>

<script>
import axios from 'axios'
import {ref} from "vue";



export default {
  name: 'Properties',
  data: function () {
    let photoArray = []
    let swipe = {id: null, start: null, end: null}
    return {
      properties: null,
      photoArray,
      swipe,
    }
  },
  methods: {
    getProperties: async function () {
      const response = ref(
          await axios
              .post('http://0.0.0.0/api/active-properties',
                  {limit: 4, order: 'DESC'})
              .then(response => this.createProperties(response.data.properties))
      )

    },
    createProperties: function (properties) {
      this.properties = properties
      console.log(properties);
      this.createPhotoArray(properties)
    },
    createPhotoArray: function (properties) {
      console.log(properties.length);
      for (let i=0; i<properties.length; i++) {
        this.photoArray.push({currentPhoto: 0, nbPhoto: properties[i].pictures.length})
      }
      console.log("photoarray: "+this.pictureArray);
    },
    nextPhoto: function (propertyIndex) {
      console.log("next");
      if (this.photoArray[propertyIndex].currentPhoto < this.photoArray[propertyIndex].nbPhoto -1) {
        this.photoArray[propertyIndex].currentPhoto++
      } else {
        this.photoArray[propertyIndex].currentPhoto = 0
      }
    },
    previousPhoto: function(propertyIndex) {
      console.log("previous");
      if (this.photoArray[propertyIndex].currentPhoto > 0) {
        this.photoArray[propertyIndex].currentPhoto--
      } else {
        this.photoArray[propertyIndex].currentPhoto = this.photoArray[propertyIndex].nbPhoto -1
      }
    },
    touchMove: function (e) {
      if (this.swipe.start === null) {
        this.swipe.start = e.targetTouches[0].clientX
      } else {
        this.swipe.end = e.targetTouches[0].clientX
      }
    },
    touchPropertyId: function (propertyIndex) {
      this.swipe.id = propertyIndex
      // console.log(this.swipe.id);
    },
    touchStart: function (e) {
      this.swipe.start = e.clientX
      // console.log(this.swipe.start);
    },
    touchEnd: function (e) {
      console.log("ici");
      // this.swipe.end = e.clientX
      // console.log(this.swipe.end);

      if (this.swipe.start !== null && this.swipe.end !== null) {
        if (this.swipe.start !== this.swipe.end && this.getDifference(this.swipe.start, this.swipe.end) > 100) {
          if (this.swipe.start < this.swipe.end) {
            console.log("previous");
            this.previousPhoto(this.swipe.id)
          } else {
            console.log("next");
            this.nextPhoto(this.swipe.id)
          }
        }
      }
      this.swipe = {id: null, start: null, end: null}

    },
    getDifference: function (a, b) {
      return Math.abs(a - b);
    },
    getLocalisation: function () {
        // get the current position
        navigator.geolocation.getCurrentPosition(onSuccess, onError);


      // handle success case
      function onSuccess(position) {
        const {
          latitude,
          longitude
        } = position.coords;

        console.log(`Your location: (${latitude},${longitude})`);
      }

      // handle error case
      function onError() {
        console.log(`Failed to get your location!`);
      }
    }
  },
  mounted() {
    this.getProperties()
    this.getLocalisation()
  }
}
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style lang="scss" scoped>
.cards-grid {
  display: grid;
  grid-template-columns: repeat(auto-fill, minmax(300px, 1fr));
  grid-gap: 20px;
  padding: 0 5px;
  max-width: 1300px;
  margin: 20px auto 100px;
}

.card {
  background: #f1f1f1;
  border-radius: 5px;
  overflow: hidden;
}

.top-img {
  display: block;
  height: 200px;
  width: 100%;
  background: #4c4c4c;
  object-fit: cover;
}

.card-image {
  height: 200px;
  background-size: cover;
  background-position: center;
  background-color: rgba(0, 0, 0, 0.2);
  background-blend-mode: overlay;
}

.card-image:hover {
  background-color: rgba(0, 0, 0, 0.3);
}

.card-image:after {
  background-color: rgba(0, 0, 0, 0.85);
}

.card-image-overlay {
  display: flex;
  flex-direction: column;
  justify-content: space-between;
  height: 100%;
  padding-top: 6px;
}

.card-image-overlay-top {
  display: flex;
  justify-content: space-between;
  align-items: start;
}

.card-image-overlay-btn {
  display: flex;
  flex-direction: column;
  align-items: end;
}

.card-image-overlay-btn span{
  background: #374971;
  display: flex;
  border-radius: 5px;
  margin-right: 6px;
  height: 23px;
  align-items: center;
}

.card-status {
  display: flex;
}

.heart, .compare {
  cursor: pointer;
}

.heart {
  justify-content: center;
  padding: 8px;
}

.heart>p, .compare>p {
  display: none;
  color: #ffffff;
  font-size: 0.8rem;
}



.compare {
  padding: 6px;
  margin-top: 3px;
}



.carousel {
  display: flex;
  justify-content: space-between;

  & span {
    padding: 15px;

    &:hover {
      cursor: pointer;
    }

    &:last-child svg {
      transform: rotate(180deg);
    }
  }

  & span svg {
    height: 20px;
    fill: #ffffff;
  }
}

.photo-nb {
  display: flex;
  justify-content: flex-end;
  color: #ffffff;

  & svg {
    height: 10px;
    fill: #ffffff;
  }
}

.heart>svg {
  height: 12px;
  fill: #ffffff;
}

.compare>svg {
  height: 15px;
  fill: #ffffff;
}

.card-status h2 {
  background-color: #374971;
  border-radius: 5px;
  color: #ffffff;
  padding: 6px 6px 0 6px;
  font-size: 1rem;
}

.card-status h2:first-child {
  margin: 0 2px 0 6px;
}

.card-address {
  background-color: rgba(55, 73, 113, 0.8);
  color: #ffffff;
  padding-top: 5px;
}

.location-point {
  height: 15px;
  fill: #ffffff;
}

.price {
  color: #374971;
}

.top-img.skeleton-anim {
  animation: skeleton 0.8s ease-in-out infinite alternate;
}

@keyframes skeleton {
  to {
    opacity: 0.6;
  }
}

.content {
  padding: 15px;
}

.skeleton-title, .skeleton-text {
  background: #4c4c4c;
  animation: skeleton 0.8s ease-in-out infinite alternate;
  width: 60%;
}

.skeleton-title {
  height: 20px;
}

.skeleton-text {
  margin-top: 10px;
  height: 10px;
}

.skeleton-text:first-of-type {
  width: 90%;
}

@media screen and (width > 768px) {
  .cards-grid {
    margin: 20px auto 40px;
    //margin-top: 200px !important;
  }

  .card:hover {
    transform: scale(1.02);
  }

  .card-image-overlay-btn {
    display: flex;
    flex-direction: column;
    align-items: end;
  }

  .heart:hover p {
    display: block;
  }

  .heart:hover svg {
    display: none;
  }

  .heart:hover {
    align-items: baseline;
    padding: 6px;
  }

  .compare:hover p {
    display: block;
  }

  .compare:hover svg {
    display: none;
  }

  .compare:hover {
    align-items: baseline;
  }

  .carousel span:hover {
    transform: scale(1.5);
  }
}

</style>
